// 增加一个报错抛出
/**
 * @param {Matrix} data - 插入的数据
 * @param {string} targetAddress - 插入的地址
 * */
export default function (data, targetAddress) {
    // 检测是否为空 如果为空则不进行任何操作
    // if (data.length === 0 || (data.length === 1 && data[0].length === 0)) return null
    var yLength = data.length;
    var xLength = data[0].length;
    Excel.run(function (ctx) {
        var workbook = ctx.workbook;
        var range;
        // 预防没有给出address的情况
        if (!targetAddress) {
            var range_1 = workbook.getSelectedRange();
            range_1.load('address');
        }
        else {
            var worksheet = ctx.workbook.worksheets.getActiveWorksheet();
            range = worksheet.getRange(targetAddress);
        }
        range.load('address');
        return ctx.sync()
            .then(function () {
            // 获取sheet 和 address
            var _a = range.address.split('!'), sheet = _a[0], address = _a[1];
            var targetWorksheet = workbook.worksheets.getItem(sheet);
            targetWorksheet.activate();
            range = targetWorksheet.getRange(address);
            range = range.getCell(0, 0); // 获取最左上角的cell
            range = range.getResizedRange(yLength - 1, xLength - 1); // 变换大小为目标矩阵大小
            range.select(); // 在excel中选中
            range.values = data;
            return ctx.sync();
        });
    });
}
//# sourceMappingURL=insert2excel.js.map